#include "baralho.h"
#include "mesa.h"

Carta verificaTopo (Monte deck, Baralho bar) {
	Carta aux;

	aux = getCarta(deck[0][1], deck[0][0], bar);
	return aux;
}

void troca_periferia (Monte mesa[24], int i, int ir, int j, int jr) {
	char aux[1][1][2];

	/* [horizontal][vertical][val/naipe] */
	aux[1][1][0] = mesa[j][i][0];
	aux[1][1][1] = mesa[j][i][1];

	mesa[j][i][0] = mesa[jr][ir][0];
	mesa[j][i][1] = mesa[jr][ir][1];

	mesa[jr][ir][0] = aux[1][1][0];
	mesa[jr][ir][1] = aux[1][1][1];
}

void embaralha_periferia (Monte mesa[24]) {
	int i, ir, j, jr;

	srand(time(0));
	for (i = 0; i < 6; i++) {
		for (j = 0; j < 16; j++) {
			ir = rand() % 6;
			jr = rand() % 16;
			troca_periferia(mesa, i, ir, j, jr);
		}
	}
}

void inicializa_mesa (Monte mesa[24]) {
	int i, j;

	for (i = 0; i < 24; i++)
		mesa[i] = criaMonte(2);
}

void cria_blocos_centrais (Monte mesa[24]) {
	Carta aux;

	//cria bloco decrescente
	aux.valor = 'K';
	aux.naipe = 'C';
	mesa[16] = colocaCarta(2, aux, mesa[16]);
	aux.naipe = 'P';
	mesa[17] = colocaCarta(2, aux, mesa[17]);
	aux.naipe = 'O';
	mesa[18] = colocaCarta(2, aux, mesa[18]);
	aux.naipe = 'E';
	mesa[19] = colocaCarta(2, aux, mesa[19]);

	//cria bloco crescente
	aux.valor = 'A';
	aux.naipe = 'C';
	mesa[20] = colocaCarta(2, aux, mesa[20]);
	aux.naipe = 'P';
	mesa[21] = colocaCarta(2, aux, mesa[21]);
	aux.naipe = 'O';
	mesa[22] = colocaCarta(2, aux, mesa[22]);
	aux.naipe = 'E';
	mesa[23] = colocaCarta(2, aux, mesa[23]);
}

/* void troca (carta baralho[], int i, int r) {
	carta aux;

	aux = baralho[i];
	baralho[i] = baralho[r];
	baralho[r] = aux;
}

void embaralha (carta baralho[], int cartas_restantes) {
	int i, r;

	for (i = 0; i < cartas_restantes; i++) {
		r = rand() % cartas_restantes;
		troca(baralho, i, r);
	}
} */

void distribui_periferia (Monte mesa[24], Baralho bar, int cartas_restantes) {
	int i, j, k;
	int cont;
	Carta barAux[104];
	
	cont = 0;
	k = 0;
	for (i = 0; i < NAIPES; i++) {
		for (j = 0; j < CARTAS; j++, k++)
			barAux[k] = bar[i][j];
	}
	for (i = 0; i < NAIPES; i++) {
		for (j = 0; j < CARTAS-2; j++, k++)
			barAux[k] = bar[i][j];
	}

	k = 0;
	while (cont < cartas_restantes) {
		for (i = 0; i < 16 && cont < cartas_restantes; i++, k++) {
			mesa[i] = colocaCarta(2, barAux[k], mesa[i]);
			cont++;
		}
	}
}

int segundos (tm* myTime) {
	int tempo;

	tempo = (myTime->tm_hour * 3600) + (myTime->tm_min * 60) + (myTime->tm_sec);
	return tempo;
}

void imprime_tabuleiro (Monte mesa[24], Baralho bar) {
	Carta teste[24];
	int i;

	for (i = 0; i < 24; i++)
		teste[i] = verificaTopo(mesa[i], bar);

	printf("	                        %c-%c %c-%c %c-%c %c-%c %c-%c %c-%c %c-%c %c-%c                            \n", teste[4].valor, teste[4].naipe, teste[5].valor, teste[5].naipe, teste[6].valor, teste[6].naipe, teste[7].valor, teste[7].naipe, teste[8].valor, teste[8].naipe, teste[9].valor, teste[9].naipe, teste[10].valor, teste[10].naipe, teste[11].valor, teste[11].naipe);
	printf("                     %c-%c                                               %c-%c                     \n", teste[3].valor, teste[3].naipe, teste[12].valor, teste[12].naipe);
	printf("              %c-%c                     %c-%c %c-%c %c-%c %c-%c                        %c-%c              \n", teste[2].valor, teste[2].naipe, teste[16].valor, teste[16].naipe, teste[17].valor, teste[17].naipe, teste[18].valor, teste[18].naipe, teste[19].valor, teste[19].naipe, teste[13].valor, teste[13].naipe);
	printf("       %c-%c                            %c-%c %c-%c %c-%c %c-%c                                %c-%c       \n", teste[1].valor, teste[1].naipe, teste[20].valor, teste[20].naipe, teste[21].valor, teste[21].naipe, teste[22].valor, teste[22].naipe, teste[23].valor, teste[23].naipe, teste[14].valor, teste[14].naipe);
	printf("%c-%c                                                                                        %c-%c\n", teste[0].valor, teste[0].naipe, teste[15].valor, teste[15].naipe);
	printf("                      0-Desiste 1-Move 2-Embaralha 3-Salva 4-Interrompe                           \n");
} 

int converte_minutos (int tempo) {
	return (tempo/60);
}

int jogada_possivel_ori (Monte mesa[24], Carta busca_ori, Baralho bar) {
	int saida;
	int i = 0;
	Carta teste;

	saida = 0;
	while (i < 16) {
		teste = verificaTopo(mesa[i], bar);
		if (busca_ori.valor == teste.valor && busca_ori.naipe == teste.naipe) {
			saida = 1;
			break;
		}
		i++;
	}
	return (saida);
}

int posicao_ori (Monte mesa[24], Carta busca, Baralho bar) {
	int i, pos[2];
	Carta teste;
	int cont = 0;
	char lixo;

	for (i = 0; i < 16; i++) {
		teste = verificaTopo(mesa[i], bar);
		if (busca.valor == teste.valor && busca.naipe == teste.naipe) {
			pos[cont] = i;
			cont++;
		}
	}

	if (cont >= 2) {
		printf("Foram encontradas DUAS cartas %c-%c, para qual delas voce quer mover? (Primeira, Segunda) [1/2]: ", busca.valor, busca.naipe);
		scanf("%d", &cont);
		lixo = getchar();
		i = pos[cont-1];
		return i;
	}
	else {
		i = pos[0];
		return i;
	}
	
}

int jogada_possivel_dest (Monte mesa[24], Carta mao_ori, Carta busca_dest, Baralho bar) {
	int i, j, k;
	Carta teste[24];
	Carta mao_dest;

	for (i = 0; i < 24; i++)
		teste[i] = verificaTopo(mesa[i], bar);

	i = 0;
	while (i < 24) {
		if (busca_dest.valor == teste[i].valor && busca_dest.naipe == teste[i].naipe) {
			mao_dest = teste[i];
			break;
		}
		i++;
	}

	if (i >= 24)
		return 0;

	j = 0;
	while (1) {
		if (vals[j] == mao_dest.valor)
			break;
		j++;
	}

	if (i < 16) {
		if (mao_ori.naipe != mao_dest.naipe)
			return 0;
		if (vals[j+1] == mao_ori.valor || vals[j-1] == mao_ori.valor)
			return 1;
		else
			return 0;
	}

	if (i >= 16 && i <= 19) {
		if (mao_dest.valor == '2')
			if (mao_ori.valor == 'A')
				return 1;
		if (mao_ori.naipe != mao_dest.naipe)
			return 0;
		if (vals[j-1] == mao_ori.valor)
			return 1;
		else
			return 0;
	}

	if (i > 19) {
		if (mao_ori.naipe != mao_dest.naipe)
			return 0;
		if (mao_dest.valor == 'A')
			if (mao_ori.valor == '2')
				return 1;
		if (vals[j+1] == mao_ori.valor)
			return 1;
		else 
			return 0;
	}
}

int posicao_dest (Monte mesa[24], Carta busca_dest, Baralho bar) {
	int i, pos[2];
	Carta teste;
	int cont = 0;
	char lixo;

	for (i = 0; i < 24; i++) {
		teste = verificaTopo(mesa[i], bar);
		if (busca_dest.valor == teste.valor && busca_dest.naipe == teste.naipe) {
			pos[cont] = i;
			cont++;
		}
	}

	if (cont >= 2) {
		printf("Foram encontradas DUAS cartas %c-%c, para qual delas voce quer mover? (Primeira, Segunda) [1/2]: ", busca_dest.valor, busca_dest.naipe);
		scanf("%d", &cont);
		lixo = getchar();
		i = pos[cont-1];
		return i;
	}
	else {
		i = pos[0];
		return i;
	}
}

int ganhou (Monte mesa[24], Baralho bar) {
	Carta teste[8];
	int i;

	for (i = 0; i < 8; i++)
		teste[i] = verificaTopo(mesa[i+16], bar);

	if (teste[0].valor == 'A' && teste[1].valor == 'A' && teste[2].valor == 'A' && teste[3].valor == 'A' && 
		teste[4].valor == 'K' && teste[5].valor == 'K' && teste[6].valor == 'K' && teste[7].valor == 'K')
		return 1;
	else
		return 0;
}

void insere_ordenado (int *v, int a, int b) {
	int i, j, temp;

	temp = v[a];
	i = a;
	while ((temp >= v[i]) && (i < b)) {
		i++;
	}
	i--; 
	if (i == b) {
		return;
	}
	else {
		for (j = a; j < i; j++) {
			v[j] = v[j + 1];
			v[j + 1] = temp;
		}
	}
}

void ins_sort (int *v, int a, int b) {
	if (a > b) {
		return;
	}
	ins_sort(v, a + 1, b);
	insere_ordenado(v, a, b);
}

void analiza_tempo (FILE *entrada, int inicio, int atual) {
	int min[11];
	int seg[11];
	int tempo[11];
	int i;
	char lixo;
	int tempo_de_jogo = atual - inicio;

	for (i = 0; i < 10; i++) {
		fscanf(entrada,"%d", &min[i]);
		fscanf(entrada,"%c", &lixo);
		fscanf(entrada,"%d", &seg[i]);
	}
	for (i = 0; i < 10; i++) {
		tempo[i] = (min[i]*100) + seg[i];
	}
	tempo[10] = (converte_minutos(tempo_de_jogo) * 100) + (tempo_de_jogo % 60);
	ins_sort(tempo, 0, 11);
	rewind(entrada);
	for (i = 0; i < 10; i++) {
		fprintf(entrada, "%2.2d:%2.2d\n", tempo[i]/100, tempo[i]%100);
	}
	fprintf(entrada, "%2.2d:%2.2d", tempo[10]/100, tempo[10]%100);
}

void reseta_baralho (Carta baralho[]) {
	int i;

	for (i = 0; i < 96; i++)
		baralho[i] = NADA;
}

void recolhe_periferia (Carta mesa[][24], Carta baralho[], int cartas_restantes) {
	int i, j, k;
	int cont;
	
	cont = 0;
	i = 0;
	k = 0;
	while (cont < 96) {
		for (j = 0; j < 16 && cont < 96; j++) {
			if (mesa[i][j].valor != NADA.valor && mesa[i][j].naipe != NADA.naipe) {
				baralho[k] = mesa[i][j];
				k++;
			}
			cont++;
		}
		i++;
	}
}

void reseta_mesa (Carta mesa[][24]) {
	int i, j;

	for (i = 0; i < 95; i++)
		for (j = 0; j < 16; j++)
			mesa[i][j] = NADA;
}

void imrpime_melhores_tempos (FILE *placar) {
	int min[10];
	int seg[10];
	int tempo[10];
	int i;
	char lixo;

	rewind(placar);
	for (i = 0; i < 10; i++) {
		fscanf(placar,"%d", &min[i]);
		fscanf(placar,"%c", &lixo);
		fscanf(placar,"%d", &seg[i]);
	}
	for (i = 0; i < 10; i++) {
		tempo[i] = (min[i]*100) + seg[i];
	}
	ins_sort(tempo, 0, 9);
	for (i = 0; i < 10; i++) {
		printf("%2.2d:%2.2d \n", tempo[i]/100, tempo[i]%100);
	}
}

int numero_do_save () {
	char s[16];
	int i = 1;
	FILE *save;

	sprintf(s, "../SAVES/SAVE%d.txt", i);

	while (1) {
		if ((save = fopen(s, "r")) == NULL)
			break;
		fclose(save);
		i++;
		sprintf(s, "../SAVES/SAVE%d.txt", i);
	}
	return i;
}

void salva_jogo (Monte mesa[23], Baralho bar, int modo, int embaralhamentos, int tempo_de_jogo, int atual, int inicio, int saveNum, int perdeu) {
	FILE *save;
	Monte aux[23];
	int i, j;
	Carta carta;
	time_t tempo_atual;
	tm *tempo;
	char s[16];

	sprintf(s, "../SAVES/SAVE%d.txt", saveNum);

	time(&tempo_atual);
	tempo = localtime(&tempo_atual);
	save = fopen(s, "w+");
	fprintf(save, "%d\n", perdeu);
	fprintf(save, "%d\n", modo);
	fprintf(save, "%d\n", embaralhamentos);
	if (modo) {
		fprintf(save, "%d %d\n", converte_minutos(tempo_de_jogo - (atual - inicio)), (tempo_de_jogo - (atual - inicio)) % 60);
	}

	/* [horizontal][vertical][val/naipe] */
	for (i = 0; i < 105; i++) {
		for (j = 0; j < 24; j++)
			fprintf(save, "%c%c ", mesa[j][i][0], mesa[j][i][1]);
		fprintf(save, "\n");
	}
	fprintf(save, "ultima vez que esse save foi carregado: %2.2d:%2.2d:%2.2d %2.2d/%2.2d/%d\n", tempo->tm_hour, tempo->tm_min, tempo->tm_sec, tempo->tm_mday, tempo->tm_mon, tempo->tm_year+1900);
	fprintf(save, "***** FIM DO SAVE *****\n");
	fclose(save);
}

void carrega_jogo (Monte mesa[23], Baralho bar, int *modo, int *embaralhamentos, int *tempo_de_jogo, int *atual, int *inicio, int saveNum, int *perdeu) {
	char s[16];
	FILE *save;
	int modoAux, embaralhamentosAux, tempo_de_jogoAux, atualAux, inicioAux, perdeuAux;
	int tempo_de_jogoMin, tempo_de_jogoSeg;
	int i, j;
	char lixo;

	sprintf(s, "../SAVES/SAVE%d.txt", saveNum);
	save = fopen(s, "r");
	fscanf(save, "%d", &perdeuAux);
	*perdeu = perdeuAux;
	fscanf(save, "%d", &modoAux);
	*modo = modoAux;
	fscanf(save, "%d", &embaralhamentosAux);
	*embaralhamentos = embaralhamentosAux;
	if (modoAux == 1) {
		fscanf(save, "%d %d", &tempo_de_jogoMin, &tempo_de_jogoSeg);
	}
	*tempo_de_jogo = tempo_de_jogoMin * 60 + tempo_de_jogoSeg;
	fscanf(save, "%c", &lixo);
	for (i = 0; i < 105; i++) {
		for (j = 0; j < 24; j++)
			fscanf(save, "%c%c ", &mesa[j][i][0], &mesa[j][i][1]);
	}
}

int saves_encontrados () {
	char s[16];
	FILE *save;
	char data[59];
	int i, modo, embaralhamentos, perdeu;
	int num = 1;
	int tempo_de_jogoMin, tempo_de_jogoSeg;

	sprintf(s, "../SAVES/SAVE%d.txt", num);
	while (1) {
		if ((save = fopen(s, "r")) == NULL)
			break;
		fscanf(save, "%d", &perdeu);
		fscanf(save, "%d", &modo);
		fscanf(save, "%d", &embaralhamentos);
		if (modo) {
			fscanf(save, "%d %d", &tempo_de_jogoMin, &tempo_de_jogoSeg);
	 		for (i = 0; i < 109*2 - 6; i++)
				fgets(data, 73, save);
		}
		else {
	 		for (i = 0; i < 109*2 - 6; i++)
				fgets(data, 73, save);
		}
		fclose(save);

		if (num == 1) {
			printf("SAVE %d: %s", num, data);
			if (modo)
				printf("                           Tempo de jogo %2.2d:%2.2d\n", tempo_de_jogoMin, tempo_de_jogoSeg);
			if (perdeu == 0)
				printf("                           Voce GANHOU essa partida!\n\n");
			else {
				if (perdeu == 1)
					printf("                           Voce PERDEU essa partida!\n\n");
				else {
					if (perdeu == 2)
						printf("                           Essa partida ainda esta em andamento!\n\n");
				}
			}
		}
		else {
			//printf("Saves encontrados: ");
			printf("                   SAVE %d: %s", num, data);
			if (modo)
				printf("                           Tempo de jogo %2.2d:%2.2d\n", tempo_de_jogoMin, tempo_de_jogoSeg);
			if (perdeu == 0)
				printf("                           Voce GANHOU essa partida!\n\n");
			else {
				if (perdeu == 1)
					printf("                           Voce PERDEU essa partida!\n\n");
				else {
					if (perdeu == 2)
						printf("                           Essa partida ainda esta em andamento!\n\n");
				}
			}
		}
		num++;
		sprintf(s, "../SAVES/SAVE%d.txt", num);
	}
	num--;
	return num;
}